function load() {
    var xhttp = new XMLHttpRequest();
    var locations = [];
    
    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            var markerTexts = this.responseText;
            var markerTextClick = markerTexts.split("\n");
            var markerText = markerTextClick.shift();
            var counter = markerTextClick.length;
            
            for(i=0; i<counter; i++) {
                locations.push({
                    lat: parseFloat(markerTextClick[i].split(";")[0]),
                    lng: parseFloat(markerTextClick[i].split(";")[1]),
                    name: markerTextClick[i].split(";")[2],
                    address: markerTextClick[i].split(";")[3],
                    students: parseInt(markerTextClick[i].split(";")[4]),
                    date: markerTextClick[i].split(";")[5],
                });
            }
            
            /* console.debug(locations); */
            initMap(markerText, markerTextClick, locations);
        }
    };
    xhttp.open("GET", "coord.csv", true);
    xhttp.send();
}

window.onload = function(){load();};
var mc; 
function initMap(markerText, markerTextClick, locations) {
    var styles =
        [
            {
              featureType : 'landscape',
              elementType : 'all',
              stylers:[{ color: "#aaabaf" }]
            },
            {
              featureType : 'poi',
              elementType : 'all',
              stylers:[{ visibility: "off" }]
            },
            /* school squares */
            /*{
              featureType : 'poi.school',
              elementType : 'labels.icon',
              stylers:[{ color: '#ffa500' }]
            },*/
            {
              featureType : 'road',
              elementType : 'all',
              stylers:[{ color: "#aaabaf" }]
            },
            {
              featureType: "road",
              elementType: "labels.icon",
              stylers: [{"visibility": "off"}]
            },
            {
              featureType : 'transit',
              elementType : 'all',
              stylers:[{ color: "#aaabaf" }]
            },
            {
              featureType : 'administrative.province',
              elementType : 'geometry',
              stylers:[{ color: "#000000" }]
            },
            {
              featureType : 'water',
              elementType : 'all',
              stylers:[{ color: "#ffffff" }]
            }
        ];
        
    var styledMap = new google.maps.StyledMapType(styles);
    
    var myOptions = {
        zoom: 2,
        center: {lat: 45, lng: 10},
        disableDefaultUI : true,
        /* clickableIcons: false, */
        mapTypeControlOptions: {
            mapTypeIds: ['map_style']
        },
        mapTypeId: 'map_style'
    };
    
      var map = new google.maps.Map(document.getElementById('map'), myOptions);
      var markerIcon = "markers/orange-marker.png";
      map.mapTypes.set('map_style', styledMap);
      var lastInput = 0;
      
    document.getElementById("searchInput").addEventListener("input", function() {
        var inputValue = document.getElementById("searchInput").value;
        if(Date.now() - lastInput > 200 && inputValue.length>4) {
            search(inputValue);
            lastInput = Date.now();
        }
    });
    document.getElementById("searchInput").addEventListener("click", function() {
    var inputValue = document.getElementById("searchInput").value;
        if(inputValue.length>4) {
            search(inputValue);
        }
    });
    
    var input = document.getElementById('pac-input');
    var autocomplete = new google.maps.places.Autocomplete(input);
    autocomplete.bindTo('bounds', map);
    
    autocomplete.addListener('place_changed', function() {
        var place = autocomplete.getPlace();
        if (!place.geometry) {
            return;
        }
        if (place.geometry.viewport) {
            map.fitBounds(place.geometry.viewport);
        } else {
            map.setCenter(place.geometry.location);
            map.setZoom(17);
        }
    });
    
    /* console.debug(locations); */
    var infowindow = new google.maps.InfoWindow({maxWidth: 350});
    var markers = locations.map(function(location, i) {
        
        if(location.date) {
            if(location.students) {
                var marker = new google.maps.Marker({
                    position: location,
                    icon: markerIcon,
                    map: map,
                    content: '<p id="schoolName">'+location.name+'</p>'+
                             '<p id="studentsParticip">'+location.students+' Students participating</p>'+
                             '<p id="registerDate">Registration date: '+location.date+'</p>'+
                             '<p id="schoolAddress">'+location.address+'</p>'
                });
            } else {
                var marker = new google.maps.Marker({
                    position: location,
                    icon: markerIcon,
                    map: map,
                    content: '<p id="schoolName">'+location.name+'</p>'+
                             '<p id="registerDate">Registration date: '+location.date+'</p>'+
                             '<p id="schoolAddress">'+location.address+'</p>'
                });
            }
        } else {
            if(location.students) {
                var marker = new google.maps.Marker({
                    position: location,
                    icon: markerIcon,
                    map: map,
                    content: '<p id="schoolName">'+location.name+'</p>'+
                             '<p id="studentsParticip">'+location.students+' Students participating</p>'+
                             '<p id="schoolAddress">'+location.address+'</p>'
                });
            } else {
                var marker = new google.maps.Marker({
                    position: location,
                    icon: markerIcon,
                    map: map,
                    content: '<p id="schoolName">'+location.name+'</p>'+
                             '<p id="schoolAddress">'+location.address+'</p>'
                });
            }
        }
        
        google.maps.event.addListener(marker, 'click', (function (marker, i, infowindow) {
            return function () {
                /* console.log('Klick! Marker=' + this.content); */
                infowindow.setContent(this.content);
                infowindow.open(map, marker);
            };
        })(marker, i, infowindow));
        
        google.maps.event.addListener(map, 'click', function() {
            if(infowindow) {
                infowindow.close();
            }
        });
        return marker;
        
    });
    var markerCluster = new MarkerClusterer(map, markers, {imagePath: 'markers/m'});   
    
    var zoom = 18;
    /* var infoWindow = new google.maps.InfoWindow({maxWidth: 350}); */
    google.maps.event.addListener(markerCluster, 'clusterclick', function(cluster) {
        if (map.getZoom() < zoom ){

            map.setCenter(cluster.center_);

            map.setZoom(map.getZoom() + 3);
        } else {
            var clusterMarkers = cluster.getMarkers();
            /* console.log(clusterMarkers); */

            var array = '';
            var num = 0; 
            for (var z = 0; z < clusterMarkers.length; z++) {
                array += clusterMarkers[z].content+"<hr>";
            }
            /* console.log(array); */

            infowindow.setContent(array); 
            infowindow.setPosition(cluster.getCenter()); 
            infowindow.open(cluster.map_);
        }
    });   
}